//
//  GetPhotoViewController.m
//  封装相册获取
//
//  Created by 史长硕 on 2018/8/22.
//  Copyright © 2018年 史长硕. All rights reserved.
//

#import "GetPhotoViewController.h"
#import "GetPhotoModel.h"
#import "HCMacro.h"
#import "PhotoView.h"
#import "UIFont+AppFont.h"
@interface GetPhotoViewController ()<TransmitSelectImageDelegate>
@property (nonatomic, strong)PhotoView *photoView;//照片视图
@end

@implementation GetPhotoViewController
#pragma mark --> life Cycle
- (void)viewDidLoad {
    [super viewDidLoad];
    self.title = @"选择相片";
    self.edgesForExtendedLayout = UIRectEdgeNone;
    self.view.backgroundColor = [UIColor whiteColor];
    [self.view addSubview:self.photoView];
    [self creatNavView];
    [self loadAllPhotoData];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    
}

#pragma mark --> private Methods
//创建导航栏
-(void)creatNavView{
    
    UIButton *button = [[UIButton alloc]initWithFrame:CGRectMake(0, 0, 44, 44)];
    [button setTitle:@"取消" forState:UIControlStateNormal];
    button.backgroundColor = [UIColor clearColor];
    [button setTitleColor:UIColorFromRGB(0x028ce5, 1.0) forState:UIControlStateNormal];
    [button addTarget:self action:@selector(cancelAction) forControlEvents:UIControlEventTouchUpInside];
    button.titleLabel.font = [UIFont appFontRegularOfSize:15];
    
    UIBarButtonItem *bar = [[UIBarButtonItem alloc]initWithCustomView:button];
    self.navigationItem.leftBarButtonItem = bar;
}

//获取图像数据
-(void)loadAllPhotoData{
    WEAKSELF
    [GetPhotoModel getPhotoAction:^(NSArray *photoArray) {
        STRONGSELF
        if (photoArray.count > 0) {
         [strongSelf.photoView reloadPhotoInfoArray:photoArray];
        }
        
    }];
}

#pragma mark --> event Methods
//点击取消按钮
-(void)cancelAction{
    if (self.presentingViewController) {
        [self dismissViewControllerAnimated:YES completion:nil];
    }else{
        [self.navigationController popViewControllerAnimated:YES];
    }
}

#pragma mark --> 选择照片返回代理协议
-(void)transmitSelectImgArray:(NSArray *)imgArray{
    if (_delegate && [_delegate respondsToSelector:@selector(backSelectImgArray:)]) {
        [_delegate backSelectImgArray:imgArray];
    }
    if (self.presentingViewController) {
        [self dismissViewControllerAnimated:YES completion:nil];
    }else{
        [self.navigationController popViewControllerAnimated:YES];
    }
}

#pragma mark --> set UI

-(PhotoView *)photoView{
    if (!_photoView) {
        _photoView = [[PhotoView alloc]initWithFrame:CGRectMake(0, 0, DeviceWidth, DeviceHeight-TopViewHeight)];
        _photoView.delegate = self;
        if (_maxImgNum.length > 0) {
          _photoView.maxImgNum = [_maxImgNum integerValue];
        }else{
          _photoView.maxImgNum = 5;
        }
        if (_minImgNum.length > 0) {
            _photoView.minImgNum = [_minImgNum integerValue];
        }else{
            _photoView.minImgNum = 1;
        }
        
    }
    return _photoView;
}


@end
