

//
//  GetPhotoModel.m
//  获取相册
//
//  Created by 史长硕 on 2018/8/17.
//  Copyright © 2018年 史长硕. All rights reserved.
//

#import "GetPhotoModel.h"
#import <Photos/Photos.h>
#import <AssetsLibrary/AssetsLibrary.h>
@implementation GetPhotoModel

//获取相册权限
+(BOOL)isGetPhotoPermission{
    if (@available(iOS 9.0, *)) {
        PHAuthorizationStatus photoAuthorStatus = [PHPhotoLibrary authorizationStatus];
        if (photoAuthorStatus == PHAuthorizationStatusNotDetermined || photoAuthorStatus == PHAuthorizationStatusAuthorized) {
            return YES;
        }else{
            return NO;
        }
        
    }else{
        ALAuthorizationStatus status = [ALAssetsLibrary authorizationStatus];
        if (status == ALAuthorizationStatusRestricted || status == ALAuthorizationStatusDenied) {
            return NO;
        }else{
            return YES;
        }
    }
}

//获取相册图片
+(void)getPhotoAction:(void (^)(NSArray *))action{
    
    //获取相册所有集合，并以照片创建时间排序
    PHFetchOptions *options = [[PHFetchOptions alloc]init];
    options.sortDescriptors = @[[NSSortDescriptor sortDescriptorWithKey:@"creationDate" ascending:YES]];
    
    //获取相机胶卷图片
    PHFetchResult *assets = [PHAsset fetchAssetsWithMediaType:PHAssetMediaTypeImage options:nil];
    PHImageRequestOptions *option = [[PHImageRequestOptions alloc]init];
    
    //设置显示模式
    option.resizeMode = PHImageRequestOptionsResizeModeNone;
    option.synchronous = NO;
    option.deliveryMode = PHImageRequestOptionsDeliveryModeFastFormat;
    
    NSMutableArray *array = [[NSMutableArray alloc]init];
    for (PHAsset *asset in assets) {
        [[PHImageManager defaultManager] requestImageDataForAsset:asset options:option resultHandler:^(NSData * _Nullable imageData, NSString * _Nullable dataUTI, UIImageOrientation orientation, NSDictionary * _Nullable info) {
            
            PhotoDetailModel *model = [[PhotoDetailModel alloc]init];
            model.localIdentifier = asset.localIdentifier;
            model.imageData = imageData;
            model.asset = asset;
            [array addObject:asset];
            if (array.count == assets.count) {
                action(array);
            }
        }];
       
    }
}

@end
