//
//  HCToastView.m
//  newHaierCash
//
//  Created by 百思为科 on 2018/5/25.
//  Copyright © 2018年 haier. All rights reserved.
//

#import "HCToastView.h"
#import "UIFont+AppFont.h"
#import "UILabel+SizeForStr.h"
#import "HCMacro.h"
@implementation HCToastView

+ (HCToastView *) defaultView{
    static HCToastView *defaultView;
    if (!defaultView) {
        defaultView=[[HCToastView alloc]init];
    }
    return defaultView;
}

- (id) init{
    if(!(self=[super init])) return nil;
    
    myAlertView = [[HCMyAlert alloc] init];
    myAlertView.alpha = 0.0f;
    active = NO;
    
    [[UIApplication sharedApplication].keyWindow addSubview:myAlertView];
    
    return self;
}

- (void) postAlertWithCenterType:(ToastCenterType)centerType andMessage:(NSString*)message {
    //判断当前是否在使用中
    if (!active) {
        [self showAlerts:message andCenterType:centerType];
    }
}

- (void) showAlerts:(NSString *) str andCenterType:(ToastCenterType)centerType{
    
    //开始使用，设置当前为使用状态
    active = YES;
    myAlertView.alpha = 0;
    [[UIApplication sharedApplication].keyWindow addSubview:myAlertView];
    [myAlertView setMessageText:str];
    
    switch (centerType) {
        case ToastCenterType_Bottom:
            myAlertView.center = CGPointMake(DeviceWidth/2, DeviceHeight * 5/6);
            break;
        case ToastCenterType_Middle:
            myAlertView.center = CGPointMake(DeviceWidth/2, DeviceHeight/2);
            break;
        case ToastCenterType_Top:
            myAlertView.center = CGPointMake(DeviceWidth/2, DeviceHeight * 1/6);
            break;
        default:
            break;
    }
    
    //设置动画
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.2];
    [UIView setAnimationDelegate:self];
    [UIView setAnimationDidStopSelector:@selector(animationStep2)];
    myAlertView.alpha = 0.8;
    [UIView commitAnimations];
}

- (void) animationStep2{
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDelay:1.0];
    [UIView setAnimationDelegate:self];
    [UIView setAnimationDidStopSelector:@selector(animationStep3)];
    myAlertView.alpha = 3;
    [UIView commitAnimations];
}


- (void) animationStep3{
    
    [myAlertView removeFromSuperview];
    active=NO;
    
}

@end




@implementation HCMyAlert

CGRect messageRect;
NSString *text;

-(id)init{
    
    self=[super initWithFrame:CGRectMake(0, 0, 100, 10)];
    if (self) {
        messageRect =CGRectInset(self.bounds, 10, 10);
    }
    return self;
}
-(void)setMessageText:(NSString *)message{
    
    text=message;
    NSDictionary *attribute = @{NSFontAttributeName: [UIFont systemFontOfSize:14]};
    
    CGSize s=[text boundingRectWithSize:CGSizeMake(150, 0) options:NSStringDrawingTruncatesLastVisibleLine | NSStringDrawingUsesLineFragmentOrigin | NSStringDrawingUsesFontLeading attributes:attribute context:nil].size;
    
    self.bounds = CGRectMake(0, 0, s.width+40, s.height+15+15);
    
    messageRect.size = s;
    messageRect.size.height += 5;
    messageRect.origin.x = 20;
    messageRect.origin.y = 15;
    
    [self setNeedsLayout];
    [self setNeedsDisplay];
}

-(void)drawRect:(CGRect)rect
{
    NSDictionary* attrs =@{NSForegroundColorAttributeName:[UIColor whiteColor]
                           ,NSFontAttributeName:[UIFont fontWithName:@"AmericanTypewriter" size:14]
                           };
    [text drawInRect:messageRect withAttributes:attrs]; //给文本限制个矩形边界，防止矩形拉伸；
}


@end

