//
//  PhotoBottomView.m
//  封装相册获取
//
//  Created by 史长硕 on 2018/8/23.
//  Copyright © 2018年 史长硕. All rights reserved.
//

#import "PhotoBottomView.h"
#import "HCMacro.h"
#import "UIFont+AppFont.h"
@interface PhotoBottomView ()
//视图
@property(nonatomic, strong)UIButton *preViewBtn;//预览按钮
@property(nonatomic, strong)UIButton *nextButton;//下一步按钮
//数据

@end
@implementation PhotoBottomView

#pragma mark --> life Cycle
-(instancetype)initWithFrame:(CGRect)frame{
    if (self = [super initWithFrame:frame]) {
        self.backgroundColor = [UIColor whiteColor];
        [self addSubview:self.preViewBtn];
        [self addSubview:self.nextButton];
    }
    return self;
}

#pragma mark --> event Methods
//点击预览按钮
-(void)touchPreViewAction{
    _block(TouchPreView);
}

//点击下一步按钮
-(void)touchNextAction{
    _block(TouchNext);
}

//刷新选择影像数量
-(void)reloadImageNum:(NSInteger)imgNum{
    if (imgNum>0) {
        [self.nextButton setTitle:[NSString stringWithFormat:@"下一步(%ld)",imgNum] forState:UIControlStateNormal];
        [self.preViewBtn setTitleColor:UIColorFromRGB(0x32beff, 1.0) forState:UIControlStateNormal];
        self.nextButton.backgroundColor = UIColorFromRGB(0x32beff, 1.0);
        self.preViewBtn.userInteractionEnabled = YES;
        self.nextButton.userInteractionEnabled = YES;
    }else{
        [self.preViewBtn setTitleColor:UIColorFromRGB(0xeeeeee, 1.0) forState:UIControlStateNormal];
        [self.nextButton setTitle:[NSString stringWithFormat:@"下一步"] forState:UIControlStateNormal];
        self.nextButton.backgroundColor = UIColorFromRGB(0xeeeeee, 1.0);
        self.preViewBtn.userInteractionEnabled = NO;
        self.nextButton.userInteractionEnabled = NO;
    }
    
}

#pragma mark --> set UI
-(UIButton *)preViewBtn{
    if (!_preViewBtn) {
        _preViewBtn = [[UIButton alloc]initWithFrame:CGRectMake(30, 10, 40, 30)];
        [_preViewBtn setTitle:@"预览" forState:UIControlStateNormal];
        _preViewBtn.backgroundColor = [UIColor whiteColor];
        _preViewBtn.titleLabel.font = [UIFont appFontRegularOfSize:15];
        _preViewBtn.userInteractionEnabled = NO;
        [_preViewBtn setTitleColor:UIColorFromRGB(0xeeeeee, 1.0) forState:UIControlStateNormal];
        [_preViewBtn addTarget:self action:@selector(touchPreViewAction) forControlEvents:UIControlEventTouchUpInside];
        [self addSubview:_preViewBtn];
    }
    return _preViewBtn;
}

-(UIButton *)nextButton{
    if (!_nextButton) {
        _nextButton = [[UIButton alloc]initWithFrame:CGRectMake(DeviceWidth-90, 10, 80, 30)];
        _nextButton.backgroundColor = UIColorFromRGB(0xeeeeee, 1.0);
        _nextButton.titleLabel.font = [UIFont appFontRegularOfSize:13];
        _nextButton.userInteractionEnabled = NO;
        [_nextButton setTitle:@"下一步" forState:UIControlStateNormal];
        [_nextButton addTarget:self action:@selector(touchNextAction) forControlEvents:UIControlEventTouchUpInside];
        [self addSubview:_nextButton];
    }
    return _nextButton;
}

@end
