//
//  PhotoCollectionViewCell.m
//  封装相册获取
//
//  Created by 史长硕 on 2018/8/22.
//  Copyright © 2018年 史长硕. All rights reserved.
//

#import "PhotoCollectionViewCell.h"
#import "HCMacro.h"
@interface PhotoCollectionViewCell ()
@property(nonatomic, strong)UIImageView *photoImgView;//底层照片视图
@property(nonatomic, strong)UIButton *selectButton;//右上角选择按钮
@property(nonatomic, strong)PHAsset *asset;//照片数据
@end
@implementation PhotoCollectionViewCell

#pragma mark --> life Cycle

-(instancetype)initWithFrame:(CGRect)frame{
    if (self = [super initWithFrame:frame]) {
        [self.contentView addSubview:self.photoImgView];
        [self.contentView addSubview:self.selectButton];
    }
    return self;
}

#pragma mark --> event Methods

//加载数据
-(void)reloadPhotoModel:(PHAsset *)model{
    self.selectButton.selected = _isSelected;
    if (![_asset isEqual:model]) {
        _asset = model;
        CGSize size;
        if (IPHONE4 || iPhone5) {
            size = CGSizeMake(DeviceWidth/3.0-20, DeviceWidth/3.0-20);
        }else{
            size = CGSizeMake((DeviceWidth-30)/4.0, (DeviceWidth-30)/4.0);
        }

        WEAKSELF
        dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
            [[PHImageManager defaultManager]requestImageForAsset:_asset targetSize:size contentMode:PHImageContentModeAspectFill options:nil resultHandler:^(UIImage * _Nullable result, NSDictionary * _Nullable info) {
                dispatch_async(dispatch_get_main_queue(), ^{
                    STRONGSELF
                    strongSelf.photoImgView.image = result;
                });
            }];

            
        });
    }
   
}

//选择视图方法
-(void)selectImageAction:(UIButton *)sender{
    sender.selected = !sender.selected;
    if (_delegate && [_delegate respondsToSelector:@selector(sendSelectCell:andSelectBool:)]) {
        [_delegate sendSelectCell:self andSelectBool:sender.selected];
    }
}

#pragma mark --> set UI

-(UIImageView *)photoImgView{
    if (!_photoImgView) {
        _photoImgView = [[UIImageView alloc]initWithFrame:CGRectMake(0, 0, self.contentView.frame.size.width, self.contentView.frame.size.height)];
        [self.contentView addSubview:_photoImgView];
    }
    return _photoImgView;
}

-(UIButton *)selectButton{
    if (!_selectButton) {
        _selectButton = [[UIButton alloc]initWithFrame:CGRectMake(self.contentView.frame.size.width-30, 0, 30, 30)];
        [_selectButton setImage:[UIImage imageNamed:@"图标_未选中"] forState:UIControlStateNormal];
        [_selectButton setImage:[UIImage imageNamed:@"图标_选中"] forState:UIControlStateSelected];
        [_selectButton addTarget:self action:@selector(selectImageAction:) forControlEvents:UIControlEventTouchUpInside];
        _selectButton.tag = 60;
        [self.contentView addSubview:_selectButton];
    }
    return _selectButton;
}


@end
