//
//  ShowPhotoCollectionViewCell.m
//  封装相册获取
//
//  Created by 史长硕 on 2018/8/23.
//  Copyright © 2018年 史长硕. All rights reserved.
//

#import "ShowPhotoCollectionViewCell.h"
#import "HCMacro.h"

@interface ShowPhotoCollectionViewCell ()
@property(nonatomic, strong)UIImageView *photoImgView;//底层照片视图
@property(nonatomic, strong)PHAsset *asset;//照片数据
@end

@implementation ShowPhotoCollectionViewCell

#pragma mark --> life Cycle
-(instancetype)initWithFrame:(CGRect)frame{
    if (self = [super initWithFrame:frame]) {
        
    }
    return self;
}

#pragma mark --> event Methods

//加载数据
-(void)reloadPhotoModel:(PHAsset *)model{
    if (![_asset isEqual:model]) {
        _asset = model;
        CGSize size = CGSizeMake(DeviceWidth, DeviceHeight-TopViewHeight);
        
        WEAKSELF
        dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
            [[PHImageManager defaultManager]requestImageForAsset:_asset targetSize:size contentMode:PHImageContentModeAspectFill options:nil resultHandler:^(UIImage * _Nullable result, NSDictionary * _Nullable info) {
                dispatch_async(dispatch_get_main_queue(), ^{
                    STRONGSELF
                    strongSelf.photoImgView.image = result;
                });
            }];
            
            
        });
    }
    
}

#pragma mark --> set UI
//底部照片展示视图
-(UIImageView *)photoImgView{
    if (!_photoImgView) {
        _photoImgView = [[UIImageView alloc]initWithFrame:CGRectMake(0, 0, self.contentView.frame.size.width, self.contentView.frame.size.height)];
        [self.contentView addSubview:_photoImgView];
    }
    return _photoImgView;
}


@end
