//
//  HCMacro.h
//  newHaierCash
//
//  Created by Will on 2017/5/25.
//  Copyright © 2017年 haier. All rights reserved.
//

#ifndef HCMacro_h
#define HCMacro_h

/*
 设备检测
 */

#define IPHONE4 ([[UIScreen mainScreen] bounds].size.height == 480)

#define iPhone5 ([UIScreen instancesRespondToSelector:@selector(currentMode)] ? CGSizeEqualToSize(CGSizeMake(640, 1136), [[UIScreen mainScreen] currentMode].size) : NO)

#define iphone6 [UIScreen mainScreen].bounds.size.height == 667

#define iphone6P [UIScreen mainScreen].bounds.size.height == 736

#define iphoneX [UIScreen mainScreen].bounds.size.height > 736


/*
 设备版本检测
 */

#define IOS8_OR_LATER SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"8.0")

#define IOS9_OR_LATER SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"9.0")

#define IOS10_OR_LATER SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"10.0")

#define ISIOS7 SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"7.0") && SYSTEM_VERSION_LESS_THAN(@"8.0")

#define ISIOS8 SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"8.0") && SYSTEM_VERSION_LESS_THAN(@"9.0")

/*
 设备版本比较
 */

//大于
#define SYSTEM_VERSION_GREATER_THAN(v) ([[[UIDevice currentDevice] systemVersion] compare:v options:NSNumericSearch] == NSOrderedDescending)

//大于等于
#define SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(v) ([[[UIDevice currentDevice] systemVersion] compare:v options:NSNumericSearch] != NSOrderedAscending)

//小于
#define SYSTEM_VERSION_LESS_THAN(v) ([[[UIDevice currentDevice] systemVersion] compare:v options:NSNumericSearch] == NSOrderedAscending)

//小于等于

#define SYSTEM_VERSION_LESS_THAN_OR_EQUAL_TO(v) ([[[UIDevice currentDevice] systemVersion] compare:v options:NSNumericSearch] != NSOrderedDescending)


/*
 设备尺寸
 */
#define DeviceWidth ([[UIScreen mainScreen] bounds].size.width)
#define DeviceHeight ([[UIScreen mainScreen] bounds].size.height)

#define TopViewHeight ([UIScreen mainScreen].bounds.size.height == 812 ? 88 : 64)
#define StatusBarHeight ([UIScreen mainScreen].bounds.size.height == 812 ? 44 : 20)
#define TabBarHeight ([UIScreen mainScreen].bounds.size.height == 812 ? 83 : 49)

#define ViewScale ([UIScreen mainScreen].bounds.size.height >= 736 ? 1 : 375.0f/414.0f)

// 尺寸获取

#define Width(x) CGRectGetWidth(x.frame)
#define Height(x) CGRectGetHeight(x.frame)


/*
 缩放比例
 */
#define scaleAdapter ((CGFloat)(DeviceWidth / 375.0))

#define scale6PAdapter ((CGFloat)(DeviceWidth / 414.0))
//图片缩放比例
#define ImageUpZScale (1.0f)
#define ImageLocalScale (0.6f)

/*
 block self
 */
#define WEAKSELF typeof(self) __weak weakSelf = self;
#define STRONGSELF typeof(weakSelf) __strong strongSelf = weakSelf;

/*
 检测
 */
#define isNull(x) (!x || [x isKindOfClass:[NSNull class]])
#define toInt(x) (isNull(x) ? 0 : [x intValue])
#define isEmptyString(x) (isNull(x) || [x isEqual:@""] || [x isEqual:@"(null)"] || (x == nil))
#define objectOrNull(obj) ((obj) ? (obj) : [NSNull null])
#define isNull(x) (!x || [x isKindOfClass:[NSNull class]])
#define StringOrNull(obj) ((obj) ? (obj) : @"")

#define StringOrZero(string) ((string.floatValue > 0) ? string : @"0")



//旧方法，需改进
#define UIColorFromRGB(rgbValue, a) [UIColor colorWithRed:((float)((rgbValue & 0xFF0000) >> 16)) / 255.0 green:((float)((rgbValue & 0xFF00) >> 8)) / 255.0 blue:((float)(rgbValue & 0xFF)) / 255.0 alpha:a]


//toast设置信息
#define kScreen_height [[UIScreen mainScreen] bounds].size.height
#define kScreen_width [[UIScreen mainScreen] bounds].size.width
#define kDefaultRect CGRectMake(0, 0, kScreen_width, kScreen_height)
#define kDefaultView [[UIApplication sharedApplication] keyWindow]




#endif /* HCMacro_h */
